-- MySQL dump 10.11
--
-- Host: localhost    Database: context_database
-- ------------------------------------------------------
-- Server version	5.0.51a-24+lenny2

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


--
-- Table structure for table `application`
--

DROP TABLE IF EXISTS `application`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `application` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` blob,
  PRIMARY KEY  (`id`),
  KEY `idx_app` (`name`,`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `bluetooth`
--

DROP TABLE IF EXISTS `bluetooth`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `bluetooth` (
  `id` int(11) NOT NULL auto_increment,
  `sensor_id` int(11) default NULL,
  `btaddress` varchar(255) NOT NULL default '',
  `friendlyname` varchar(255) default NULL,
  `user_id` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `sensor_id` (`sensor_id`),
  KEY `bluetooth_ibfk_3` (`user_id`),
  CONSTRAINT `bluetooth_ibfk_1` FOREIGN KEY (`sensor_id`) REFERENCES `sensor` (`id`),
  CONSTRAINT `bluetooth_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=20810 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `bluetoothproximity`
--

DROP TABLE IF EXISTS `bluetoothproximity`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `bluetoothproximity` (
  `id` int(11) NOT NULL auto_increment,
  `context_element_id` int(11) NOT NULL default '0',
  `bluetooth_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `context_element_id` (`context_element_id`),
  KEY `bluetooth_id` (`bluetooth_id`),
  CONSTRAINT `bluetoothproximity_ibfk_1` FOREIGN KEY (`context_element_id`) REFERENCES `contextelement` (`id`),
  CONSTRAINT `bluetoothproximity_ibfk_2` FOREIGN KEY (`bluetooth_id`) REFERENCES `bluetooth` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=9879767 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `contextatom`
--

DROP TABLE IF EXISTS `contextatom`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `contextatom` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `datatype` varchar(255) NOT NULL default '',
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `description` blob,
  PRIMARY KEY  (`id`),
  KEY `datatype_idx` (`datatype`)
) ENGINE=InnoDB AUTO_INCREMENT=85 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `contextdata`
--

DROP TABLE IF EXISTS `contextdata`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `contextdata` (
  `id` int(11) NOT NULL auto_increment,
  `element_id` int(11) NOT NULL default '0',
  `atom_id` int(11) NOT NULL default '0',
  `sensor_id` int(11) default NULL,
  `value` blob,
  PRIMARY KEY  (`id`),
  KEY `element_id` (`element_id`),
  KEY `atom_id` (`atom_id`),
  KEY `sensor_id` (`sensor_id`),
  KEY `contextdata_atom` (`atom_id`,`id`),
  KEY `atom_element_idx` (`atom_id`,`element_id`),
  CONSTRAINT `contextdata_ibfk_1` FOREIGN KEY (`element_id`) REFERENCES `contextelement` (`id`),
  CONSTRAINT `contextdata_ibfk_2` FOREIGN KEY (`atom_id`) REFERENCES `contextatom` (`id`),
  CONSTRAINT `contextdata_ibfk_3` FOREIGN KEY (`sensor_id`) REFERENCES `sensor` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=97005446 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `contextelement`
--

DROP TABLE IF EXISTS `contextelement`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `contextelement` (
  `id` int(11) NOT NULL auto_increment,
  `date_received` datetime NOT NULL default '0000-00-00 00:00:00',
  `nro_measurements` int(11) NOT NULL default '0',
  `date_sent` datetime default NULL,
  `session_id` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `date_received` (`date_received`),
  KEY `session_idx` (`session_id`),
  KEY `session_date` (`session_id`,`date_received`),
  CONSTRAINT `contextelement_ibfk_1` FOREIGN KEY (`session_id`) REFERENCES `session` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7047967 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `sensor`
--

DROP TABLE IF EXISTS `sensor`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `sensor` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `description` blob,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6914 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `sensorvalue`
--

DROP TABLE IF EXISTS `sensorvalue`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `sensorvalue` (
  `id` int(11) NOT NULL auto_increment,
  `sensor_id` int(11) NOT NULL default '0',
  `atom_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `sensor_id` (`sensor_id`),
  KEY `atom_id` (`atom_id`),
  CONSTRAINT `sensorvalue_ibfk_1` FOREIGN KEY (`sensor_id`) REFERENCES `sensor` (`id`),
  CONSTRAINT `sensorvalue_ibfk_2` FOREIGN KEY (`atom_id`) REFERENCES `contextatom` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=98669 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `session`
--

DROP TABLE IF EXISTS `session`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `session` (
  `id` int(11) NOT NULL auto_increment,
  `application_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `application_id` (`application_id`),
  KEY `idx_app_user` (`application_id`,`user_id`,`id`),
  KEY `uid_created` (`user_id`,`created`),
  CONSTRAINT `session_ibfk_1` FOREIGN KEY (`application_id`) REFERENCES `application` (`id`),
  CONSTRAINT `session_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5558 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `sessiondata`
--

DROP TABLE IF EXISTS `sessiondata`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `sessiondata` (
  `id` int(11) NOT NULL auto_increment,
  `session_id` int(11) NOT NULL default '0',
  `element_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `session_id` (`session_id`),
  KEY `element_id` (`element_id`),
  KEY `session_element_idx` (`session_id`,`element_id`),
  KEY `element_id_idx` (`element_id`),
  KEY `element_session_idx` (`element_id`,`session_id`),
  CONSTRAINT `sessiondata_ibfk_1` FOREIGN KEY (`session_id`) REFERENCES `session` (`id`),
  CONSTRAINT `sessiondata_ibfk_2` FOREIGN KEY (`element_id`) REFERENCES `contextelement` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4502020 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `user` (
  `id` int(11) NOT NULL auto_increment,
  `btaddress` varchar(255) default NULL,
  `name` varchar(255) NOT NULL default '',
  `pwd` varchar(255) NOT NULL default '',
  `type` int(11) NOT NULL default '0',
  `email` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  KEY `name` (`name`),
  KEY `name_id_idx` (`name`,`id`)
) ENGINE=InnoDB AUTO_INCREMENT=659 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2009-12-28 12:31:50
