package hiit.parser.rule;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Hashtable;

public class BluetoothProximityRule implements BetelgeuseParserRule {

	public String[] getParamNames() {
		return new String[]{"BTDevices"};
	}

	public int[] getReaderTypes() {
		return new int[0];
	}

	public int process(Statement statement, int[] message, long elementId, int numberOfParameters, 
	        long sensorId, Hashtable<Integer, Long> mappings, 
            Hashtable<Long, String>  dbId_paramName, int sensorType, long timestamp) {
		return 0;
	}

	public int process(Statement statement, String param, long elementId, long sensorId, long paramDbId, String paramName, long timestamp) {
		/*
			 bluetooth: add a line for each _new_ discovered device if 
			 bluetooth data is received
			 (check for duplicates)
			 bluetoothproximity: add a link to contextelement from each bluetooth
			 address that was in the data
		 */
		/* value is bluetooth data, in the form:
		 * AABBCCDDEEFF7bluegps
		 * 123456789012 frdlynm
		 *             L
		 */
		int rtn = 0;
		int success = -1;
		String update = null;
		ResultSet rs = null;

		param = param.replaceAll("'", "''");

		//TODO fixthis later
		if(param.equals("\\"))
			return rtn;
		/* contextdata: add a line for each received measurement:
		 elementid, dbid, dbSensor, value */

		try {
			// Add each data line:
			update = "insert into contextdata values(0," + elementId + ", "+ paramDbId + ", " + sensorId + ", '" + param + "');";
			success = statement.executeUpdate(update);
			rtn = 1;
		} catch (SQLException e) {
			System.err.println("Update failed. "+ update + " exception: "+ e);
			return rtn;
		}
		if (success != 1) {
			System.err.println("Update failed. "+ update + " error: "+ success);
			return rtn;
		}

		while (param.length() > 0){
			int nextBreak = param.indexOf('\n');
			String oneField = null;
			if (nextBreak == -1){
				break;
			}else{
				oneField = param.substring(0, nextBreak);
			}
			param = param.substring(nextBreak + 1);

			int nextSpace = oneField.indexOf(' ');
			String bta = oneField.substring(0, nextSpace);
			String fname = oneField.substring(nextSpace +1);

			long bluetoothid = -1;
			String query = "select id from bluetooth where btaddress='" +  bta + "' and friendlyname='" + fname + "' limit 1;";
			try{
				rs = statement.executeQuery(query);
				if (!rs.first()){
					//  (check for duplicates), no duplicate found, add this
					try{
						update = "insert into bluetooth values(0, null, '"+ bta + "', '"+ fname + "', NULL);";
						// NULL, no application reference by default
						success = statement.executeUpdate(update, Statement.RETURN_GENERATED_KEYS);
					} catch (SQLException e){
						System.err.println("Update failed. "+ update + " exception: "+ e);
						return rtn;
					}
					if (success == 1){
						rs = statement.getGeneratedKeys();
						if(rs.first())
							bluetoothid = rs.getLong(1);
					}
					else {
						System.err.println("Update failed. "+ update + " error: "+ success);
						return rtn;
					}
				}else{
					bluetoothid = rs.getLong("id");
				}

			} catch (SQLException e){
				System.err.println("Unable to execute query: "+ query + ", exception: " + e);

			}
			// Now there is a line in bluetooth that has what we want.
			// It is identified by bluetoothid.

			/* bluetoothproximity: add a link to contextelement from each bluetooth
				 address that was in the data
			 */
			try{
				update = "insert into bluetoothproximity values(0, " + elementId + ", "+ bluetoothid + ");";
				success = statement.executeUpdate(update, Statement.RETURN_GENERATED_KEYS);
			} catch (SQLException e){
				System.err.println("Unable to execute update: "+ update + ", exception: " + e);
			}
			if (success != 1){
				System.err.println("Update failed. "+ update + " error: "+ success);
				return rtn;
			}

			// now we have done everything, I think.
		}
		return rtn;
	}

	public boolean addParameterData(String name) {
		//Means: "Do not add Bluetooth data to the database, i'll do it"
		return false;
	}

	public boolean addSensorData(int type) {
		//Means: "Do not add Bluetooth data to the database, i'll do it"
		return false;
	}

	public String getRuleName() {
		return "Bluetooth Proximity Rule";
	}
}
