package hiit.transceiver;

import java.io.IOException;
import java.net.Socket;

public interface Transceiver {
	
	public void readFrom(Socket s);
	
	/**
	 * Reads <emp>lth</emp> bytes from the input stream into <emp>arr</emp>, starting from array index <emp>from</emp>
	 * @param arr The array to save the read bytes into.
	 * @param from The index to start filling the array from.
	 * @param lth How many bytes to read from the input stream.
	 * @return How many bytes were read.
	 */
	
	public int read(int[] arr, int from, int lth);
	
	public int read();
	
	public void write(String message) throws IOException;
	
	public void write(byte[] message) throws IOException;
	
	public void close();
	
	public void reconnect();

}
