package hiit.parser.rule;

import java.sql.SQLException;
import java.sql.Statement;
import java.util.Hashtable;

public class AliveAccelerationRule implements BetelgeuseParserRule{

	public String[] getParamNames() {
		return new String[]{"XAcc Byte", "YAcc Byte", "ZAcc Byte"};
	}

	public int[] getReaderTypes() {
		return new int[0];
	}

	public int process(Statement statement, int[] message, long elementId, int numberOfParameters, 
	        long sensorId, Hashtable<Integer, Long> mappings, 
	        Hashtable<Long, String>  dbId_paramName, int sensorType, long timestamp) {
		return 0;
	}

	public int process(Statement statement, String param, long elementId, long sensorId, 
	        long paramDbId, String paramName, long timestamp) {
		param = "" + ((Integer.parseInt(param) - 127.5) / 63.75);
		int success = -1;
		String update = null;
		try {
			// Add each data line:
			update = "insert into contextdata values(0," + elementId + ", "+ paramDbId + ", " + sensorId + ", '" + param + "');";
			success = statement.executeUpdate(update);
		} catch (SQLException e) {
			System.err.println("Update failed. "+ update + " exception: "+ e);
			return 0;
		}
		if (success != 1) {
			System.err.println("Update failed. "+ update + " error: "+ success);
			return 0;
		}
		return 1;
	}

	public boolean addParameterData(String name) {
		//Means: "Do not add acceleration data to the database"
		return false;
	}

	public boolean addSensorData(int type) {
//		Means: "Do not add acceleration data to the database"
		return false;
	}

	public String getRuleName() {
		return "Alive Accelerometer Rule";
	}

}
