package hiit.transceiver;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

public class ByteStreamTransceiver implements Transceiver{
	
	private Socket s;
	private InputStream in;
	private OutputStream out;
	
	public ByteStreamTransceiver (Socket s, InputStream in, OutputStream out){
		this.s = s;
		this.in = in;
		this.out = out;
	}
	
	public void close() {
		try{
			s.close();
			in.close();
			out.close();
		}catch (IOException e){
			//We don't care about this...
		}
	}

	public int read() {
		try {
			return this.in.read();
		} catch (IOException e) {
		}
		return -1;
	}

	public void readFrom(Socket s) {
		// TODO Auto-generated method stub
		
	}

	public void reconnect() {
		// TODO Auto-generated method stub
		
	}

	public void write(String message) throws IOException{
		this.out.write(message.getBytes());
		this.out.flush();
	}
	
	public void write(byte[] message) throws IOException{
		this.out.write(message);
		this.out.flush();
	}
	
	/**
	 * Reads <emp>lth</emp> bytes from the input stream into <emp>arr</emp>, starting from array index <emp>from</emp>
	 * @param arr The array to save the read bytes into.
	 * @param from The index to start filling the array from.
	 * @param lth How many bytes to read from the input stream.
	 * @return How many bytes were read.
	 */
	public int read(int[] arr, int from, int lth){
		if (lth == 0)
			return 0;
		
		for (int i = from; i < lth; ++i){
			try {
				arr[i] = in.read(); 
			} catch (IOException e) {
				System.err.println("[BPS]: Unable to read "+ lth +" bytes.");
				return i+1;
			}
		}
		return lth; 
	}	

}
