package hiit.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class DbConnectivity {
	public static final int DEFAULT_PORT = 3306;
	//public static final int DEFAULT_PORT = 12931;


	public static Connection getConnection()
	{	
		return getConnectionFromFile();
	}


	public static Connection getConnection(String user, String pwd, String db, int dbport) 
	{
		Connection conn;

		try {
			// Load the JDBC driver
			String driverName = "com.mysql.jdbc.Driver"; // MySQL MM JDBC
			// driver
			Class.forName(driverName);

			// Create a connection to the database
			String url = "jdbc:mysql://127.0.0.1:" + dbport + "/"+ db + "?autoReconnect=true";
			// String url = "jdbc:mysql://" + serverName +":"+ port + "/" + mydatabase; //
			// a JDBC url
			conn = DriverManager.getConnection(url, user, pwd);
			return conn;
		} catch (ClassNotFoundException e) {
			System.out.println("Could not find class name for driver" + e);
			// Could not find the database driver
			return null;
		} catch (SQLException e) {
			System.out.println("Could not connect to database " + e);
			// Could not connect to the database
			return null;
		}
	}    

	public static Connection getConnectionFromFile()
	{
		File confFile = new File("configuration.txt");
		String user = "";
		String pwd = "";
		String db = "";
		String delimeter = "=";
		String[] temp;

		int dbport = 0;

		try {

			BufferedReader input =  new BufferedReader(new FileReader(confFile));
			try {
				String line = null; 

				while (( line = input.readLine()) != null)
				{
					if (line.charAt(0) == '#')
						continue;

					temp = line.split(delimeter);

					if (temp[0].compareToIgnoreCase("user") == 0)
					{
						user = temp[1];
					}
					else if (temp[0].compareToIgnoreCase("password") == 0)
					{
						pwd = temp[1];
					}
					else if (temp[0].compareToIgnoreCase("database") == 0)
					{
						db = temp[1];
					}
					else if (temp[0].compareToIgnoreCase("port") == 0)
					{
						dbport = Integer.parseInt(temp[1]);
					}
					else
					{
						System.out.println("Invalid parameter name: " + temp[0]);
					}
				}
			}
			finally {
				input.close();
			}
		}
		catch (IOException ex){
			ex.printStackTrace();
		}
		return getConnection(user, pwd, db, dbport);
	}
}
